/* coroutines */

#include <stdlib.h>
#include <stdio.h>
// #include <setjmp.h>

// #define int short

#define NREGS 18

typedef __int64 myjmp_buf[NREGS];

__int64 mysetjmp (myjmp_buf env)
{
	asm (R"(
		movq	16(%rbp), %rax
		addq	$8, %rax
		movq	%rbx, (%rax)
	
		movq	16(%rbp), %rax
		addq	$16, %rax
		movq	%rcx, (%rax)
		
		movq	16(%rbp), %rax
		addq	$24, %rax
		movq	%rdx, (%rax)

		movq	16(%rbp), %rax
		addq	$32, %rax
		movq	%rsi, (%rax)
	
		movq	16(%rbp), %rax
		addq	$40, %rax
		movq	%rdi, (%rax)

		movq	16(%rbp), %rax
		addq	$64, %rax
		movq	%r8, (%rax)

		movq	16(%rbp), %rax
		addq	$72, %rax
		movq	%r9, (%rax)

		movq	16(%rbp), %rax
		addq	$80, %rax
		movq	%r10, (%rax)
	
		movq	16(%rbp), %rax
		addq	$88, %rax
		movq	%r11, (%rax)

		movq	16(%rbp), %rax
		addq	$96, %rax
		movq	%r12, (%rax)

		movq	16(%rbp), %rax
		addq	$104, %rax
		movq	%r13, (%rax)

		movq	16(%rbp), %rax
		addq	$112, %rax
		movq	%r14, (%rax)

		movq	16(%rbp), %rax
		addq	$120, %rax
		movq	%r15, (%rax)

		// Stack frame : 
		// %rsp ------------------> ...
		// ...
		// %rbp ------------------> %rbp caller
		// %rbp+8                   %rip caller
		// %rbp+16 = %rsp caller -> ...
		// ...
		// %rbp caller -----------> ...
		// ...
		
		// %rsp caller = %rsp + 2 words = %rsp+16
		movq	16(%rbp), %rax
		addq	$48, %rax
		movq	%rbp, (%rax)
		addq $16, (%rax)
		
		// %rbp caller = (%rbp)
		movq	16(%rbp), %rax
		addq	$56, %rax
		movq	%rbp, %rbx
		movq (%rbx), %rbx
		movq	%rbx, (%rax)
		
		// %rip caller = (%rbp + 1 word) = (%rbp+8)
		movq	16(%rbp), %rax
		addq	$128, %rax
		movq	%rbp, %rbx
		addq $8, %rbx 
		movq (%rbx), %rbx
		movq	%rbx, (%rax)		

		)");
		return 0;
}

void mylongjmp (myjmp_buf env, __int64 value)
{
__int64 r;
	r = env[1];
	r = env[2];
	r = env[3];
	asm (R"(
		movq	16(%rbp), %rax
		movq	8(%rax), %rax
		movq	%rax, %rbx

		movq	16(%rbp), %rax
		movq	16(%rax), %rax
		movq	%rax, %rcx

		movq	16(%rbp), %rax
		movq	24(%rax), %rax
		movq	%rax, %rdx

		movq	16(%rbp), %rax
		movq	32(%rax), %rax
		movq	%rax, %rsi
		
		movq	16(%rbp), %rax
		movq	40(%rax), %rax
		movq	%rax, %rdi
		
		movq	16(%rbp), %rax
		movq	64(%rax), %rax
		movq	%rax, %r8
		
		movq	16(%rbp), %rax
		movq	72(%rax), %rax
		movq	%rax, %r9
		
		movq	16(%rbp), %rax
		movq	80(%rax), %rax
		movq	%rax, %r10
		
		movq	16(%rbp), %rax
		movq	88(%rax), %rax
		movq	%rax, %r11

		movq	16(%rbp), %rax
		movq	96(%rax), %rax
		movq	%rax, %r12

		movq	16(%rbp), %rax
		movq	104(%rax), %rax
		movq	%rax, %r13
		
		movq	16(%rbp), %rax
		movq	112(%rax), %rax
		movq	%rax, %r14
		
		movq	16(%rbp), %rax
		movq	120(%rax), %rax
		movq	%rax, %r15

		// %rsp
		movq	16(%rbp), %rax
		movq	48(%rax), %rax
		movq	%rax, %rsp

		// %rbp
		movq	16(%rbp), %rax
		movq	56(%rax), %rax
		movq	%rax, %rbx
	
		// %rip
		movq	16(%rbp), %rax
		movq	128(%rax), %rax
		push	%rax
		
		// result = value
		movq	24(%rbp), %rax
		// %rbp
		movq	%rbx, %rbp 
		ret

	)");
	
}

struct coroutine
{
	myjmp_buf *calling;
	myjmp_buf *env;
};

void *jmpval;

int *getsp ()
{
int *a;
	a = (int *)&a;
	a += 3;
	return a;
}

int call_with_stack (int *stack, int (*f)(), int x)
{
int *sp;
	sp = getsp();
	{
		int buf[sp-stack];
		return (*f) (x);
	}
}

void *start_coroutine (struct coroutine *cr,
	void *(*f) (/* void *p, struct coroutine *cr */),
	void *p, int *stack)
{
int x;
void *y;
int *_SP;
int test;
char *r;
	x = mysetjmp (*(cr->calling));
	if (x == 0)
	{
		asm (R"(
			movq	40(%rbp), %rax
			movq	%rax, %rsp
		)");
		r = (*f) (p, cr);
		//sp = (int *)234; sp = savesp; sp = (int *)567
		asm (R"(
			movq	%rbp, %rsp
			subq	$48, %rsp
		)");
		return r;
		//test = 123;
		//_SP = stack;
		//test = 456;
		/*_SP = getsp();
		{
			int buf[_SP-stack];		
			y = (*f) (p, cr);
			return y;
		}*/
	}
	else
	{
		return jmpval;
	}
}

void *call_coroutine (struct coroutine *cr, void *entree)
{
int x;
	x = mysetjmp (*(cr->calling));
	if (x == 0)
	{
		jmpval = entree;
		mylongjmp (*(cr->env), 1);
		printf ("Error calling coroutine\n");
	}
	else
	{
		return jmpval;
	}
}

void *coroutine1 (char *p, struct coroutine *me)
{
void *x;
struct coroutine calling;
	calling.calling = me->env;
	calling.env = me->calling;
	printf ("Lancement coroutine avec parametre <%s>\n", p);
	x = call_coroutine (&calling, "1er parametre coroutine->appelant");
	printf ("Appelant retourne <%s> la 1ere fois\n", (char *)x);
	x = call_coroutine (&calling, "2eme parametre coroutine->appelant");
	printf ("Appelant retourne <%s> la 2eme fois\n", (char *)x);
	/* return "Fin coroutine"; */
	x = call_coroutine (&calling, "3eme parametre coroutine->appelant");
}

void test_coroutine ()
{
struct coroutine cr;
myjmp_buf calling, env;
#define STACK_SIZE 1000
int stack [STACK_SIZE];
void *x;
	cr.calling = &calling;
	cr.env = &env;
	x = start_coroutine (&cr, coroutine1, "Parametre lancement",
		stack + STACK_SIZE - 100);
	printf ("Lancement retourne <%s>\n", (char *)x);
	x = call_coroutine (&cr, "1er appel");
	printf ("1er appel retourne <%s>\n", (char *)x);
	x = call_coroutine (&cr, "2eme appel");
	printf ("2eme appel retourne <%s>\n", (char *)x);
	exit(0);
}

/*
int main ()
{
	printf("main=0x%x\n",main);
	test_coroutine ();
	exit(0);
}
*/



